package org.example

import org.example.data.ShoesRepositoryImpl
import org.example.data.UserRepository
import org.example.data.UserRepositoryImpl
import org.example.domain.ShoesUseCase
import org.example.domain.ShoesUseCaseImpl
import org.example.domain.UserUseCaseImpl
import org.example.ui.ShoesUI
import org.example.ui.UserUI

fun main() {
    val userRepository = UserRepositoryImpl()
    val userUseCase = UserUseCaseImpl(userRepository)
    val userUI = UserUI(userUseCase)
    val shoesRepository = ShoesRepositoryImpl()
    val shoesUseCase = ShoesUseCaseImpl(shoesRepository)
    val shoesUI = ShoesUI(shoesUseCase)
    while (true) {
        println("Выберите действие:")
        println("1 - Регистрация")
        println("2 - Авторизация")
        println("3 - Изменить профиль")
        println("4 - Изменить пароль")
        println("5 - Работа с продкутами")
        val c = readln()
        when (c) {
            "1" -> userUI.registration()
            "2" -> userUI.authorize()
            "3" -> userUI.changeProfile()
            "4" -> userUI.changePassword()
            "5" -> shoesUI.main()

        }
    }

}