package org.example.data

import org.example.data.model.ShoesDTO
import org.example.data.model.UserDTO
import org.example.domain.request.AddShoesRequest

class ShoesRepositoryImpl: ShoesRepository {
    private val shoes: MutableList<ShoesDTO> = shoesList.toMutableList()
    override fun addShoes(addShoesRequest: AddShoesRequest): ShoesDTO {
        val newShoes = ShoesDTO(
            productId = shoes.size + 1,
            productName = addShoesRequest.productName,
            cost = addShoesRequest.cost,
            count = addShoesRequest.count,
            photo = addShoesRequest.photo,
            description = addShoesRequest.description.toString()
        )

        shoes.add(newShoes)
        return newShoes
    }

    override fun removeShoes(productId:Int): Boolean {
        return shoes.removeIf{it.productId == productId }
    }

    override fun updateShoes(productId: Int,updatedShoes: ShoesDTO): ShoesDTO {
        val oldShoes = shoes.firstOrNull{it.productId == productId}
        checkNotNull(oldShoes)
        oldShoes.productName = updatedShoes.productName
        oldShoes.cost = updatedShoes.cost
        oldShoes.count = updatedShoes.count
        oldShoes.photo = updatedShoes.photo
        oldShoes.description = updatedShoes.description
        return oldShoes

    }

    override fun getAllShoes(): List<ShoesDTO> = shoes



    override fun findShoesById(productId: Int): ShoesDTO {
        val findShoes = shoes.firstOrNull{it.productId == productId}
        checkNotNull(findShoes)
        return findShoes
    }


}