package org.example.domain

import org.example.data.model.ShoesDTO
import org.example.domain.request.AddShoesRequest

interface ShoesUseCase {

    fun addProductToBasket()

    fun addProductToFavorite()

    fun addShoes(addShoesRequest: AddShoesRequest): ShoesDTO

    fun removeShoes(productId: Int): Boolean
    fun updateShoes(productId: Int, updatedShoes: ShoesDTO): ShoesDTO
    fun getAllShoes():List<ShoesDTO>
    fun findShoesById(productId: Int): ShoesDTO

}