package org.example.ui

import org.example.data.model.ShoesDTO
import org.example.domain.ShoesUseCase
import org.example.domain.request.AddShoesRequest


class ShoesUI(private val shoesUseCase: ShoesUseCase) {


    fun main(){
        while (true){
            println("Выберите действие:")
            println("1 - Показать все товары")
            println("2 - Удалить товар")
            println("3 - Найти товар")
            println("4 - Обновить товар")
            println("5 - Добавить")
            println("6 - Вернуться назад (пока не рабоатает)")
            val c = readln()
            when(c){
                "1"-> getAllShoes()
                "2"-> removeShoesById()
                "3"-> findShoesById()
                "4"-> updateShoes()
                "5"-> addShoes()
            }
        }
    }
    fun addShoes(){
        println("Введите название товара")
        var productName = readln()
        checkNotNull(productName){"Имя не должно быть пустым"}
        println("Введите стоимость")
        var cost = readln()
        checkNotNull(cost){"Стоимость должна быть указана"}
        println("Введите количество товара")
        var count = readln()
        checkNotNull(count){"Количество должно быть указано"}
        println("Введите ссылку на фото")
        var photo = readln()
        checkNotNull(photo){"Ссылка на фото должна быть"}
        println("Введите описание товара")
        var description = readln()
        checkNotNull(description){"Описание товара не должно быть пустым"}
        val addShoesRequest = AddShoesRequest(
            productName = productName,
            cost = cost,
            count = count.toInt(),
            photo = photo,
            description = description
        )
        val newShoes = shoesUseCase.addShoes(addShoesRequest)

    }

    fun removeShoesById(){
        println("Введите id продукта, который хотите удалить")
        var productId = readln().toInt()
        checkNotNull(productId){"ID не должно быть пустым"}
        var removeShoes = shoesUseCase.removeShoes(productId)
    }

    fun updateShoes(){
        println("Введите id товара, который хотите обноновить ")
        val productId = readln().toInt()
        checkNotNull(productId){"ID не должно быть пустым"}
        println("Введите название товара")
        var productName = readln()
        checkNotNull(productName){"Имя не должно быть пустым"}
        println("Введите стоимость")
        var cost = readln()
        checkNotNull(cost){"Стоимость должна быть указана"}
        println("Введите количество товара")
        var count = readln()
        checkNotNull(count){"Количество должно быть указано"}
        println("Введите ссылку на фото")
        var photo = readln()
        checkNotNull(photo){"Ссылка на фото должна быть"}
        println("Введите описание товара")
        var description = readln()
        checkNotNull(description){"Описание товара не должно быть пустым"}
        val newProduct = ShoesDTO(
            productName = productName,
            cost = cost,
            count = count.toInt(),
            photo = photo,
            description = description,
            productId = productId
        )
        shoesUseCase.updateShoes(productId,newProduct)
    }

    fun findShoesById(){
        println("Введите id продукта, который хотите найти")
        var productId = readln().toInt()
        checkNotNull(productId){"ID не должно быть пустым"}
        println(shoesUseCase.findShoesById(productId))
    }

    fun getAllShoes(){
        val allShoes = shoesUseCase.getAllShoes()
        allShoes.forEach{
            println(it)
        }
        println()
    }

}